#ifndef MSP_GL_AMBIENTOCCLUSION_H_
#define MSP_GL_AMBIENTOCCLUSION_H_

#include "framebuffer.h"
#include "mesh.h"
#include "postprocessor.h"
#include "program.h"
#include "programdata.h"
#include "rendertarget.h"
#include "texture2d.h"
#include "texturing.h"

namespace Msp {
namespace GL {

/**
Implements screen-space ambient occlusion.

http://en.wikipedia.org/wiki/Screen_Space_Ambient_Occlusion
*/
class AmbientOcclusion: public PostProcessor
{
private:
	Texture2D rotate_lookup;
	RenderTarget occlude_target;
	Texturing texturing;
	Program occlude_shader;
	Program combine_shader;
	ProgramData shdata;
	const Mesh &quad;

public:
	AmbientOcclusion(unsigned, unsigned, float);

	void set_depth_ratio(float);
	void set_darkness(float);

	virtual void render(Renderer &, const Texture2D &, const Texture2D &);
};

} // namespace GL
} // namespace Msp

#endif
