#ifndef MSP_GL_TEXUNIT_H_
#define MSP_GL_TEXUNIT_H_

#include <vector>

namespace Msp {
namespace GL {

class TexEnv;
class TexGen;
class Texture;

/**
Keeps track of texture unit related state.  Mostly for internal use.
*/
class TexUnit
{
private:
	unsigned index;
	bool legacy;
	const Texture *texture;

	static std::vector<TexUnit> units;
	static TexUnit *cur_unit;

	TexUnit();

public:
	unsigned get_index() const { return index; }
	bool supports_legacy() const { return legacy; }
	bool set_texture(const Texture *);
	const Texture *get_texture() const { return texture; }
	void bind();

	static unsigned get_n_units();
	static unsigned get_n_legacy_units();
	static TexUnit &get_unit(unsigned);
	static TexUnit &current();
	static TexUnit *find_unit(const Texture *);
};

} // namespace GL
} // namespace Msp

#endif
